vexalarm_Testmode_Spells = {}
vexalarm_Testmode_Frames = 0

function vexalarm.testmode.handler(val)
	vexalarm.testmode.activated = val
	
	if val then
		vexalarm.testmode.collectSpells()
		vexalarm.testmode.animation()
		vexalarm.testmode.recolor = false
	end
	vexalarm.frames.toggleMovable(val)
	vexalarm.testmode.toggleFontframes()
	vexalarm.testmode.recolorFrame()
end

function vexalarm_Testmode_nonAniFuncs()
	if vexalarm.testmode.activated then
		vexalarm.frames.toggleMovable(val)
		vexalarm.testmode.toggleFontframes()
		vexalarm.testmode.recolorFrame()
	end
end

function vexalarm.testmode.getRndSpell(frame)
	local returnvalue = nil
	local rnd = 1
	
	if vexalarm_Testmode_Spells[frame] ~= nil then
		if #vexalarm_Testmode_Spells[frame] > 0 then
			rnd = math.random(1,#vexalarm_Testmode_Spells[frame])
			returnvalue = vexalarm_Testmode_Spells[frame][rnd]
		end
	end
	
	return returnvalue
end

function vexalarm.testmode.getRndFrame()
	local returnvalue = nil
	local rnd = 1
	
	if vexalarm_Testmode_Spells ~= nil then
		if vexalarm_Testmode_Frames > 0 then
			rnd = math.random(1,vexalarm_Testmode_Frames)
			local counter = 0
			for frame in pairs(vexalarm_Testmode_Spells) do
				counter = counter + 1
				if counter == rnd then
					returnvalue = frame
				end
			end
		end
	end
	
	return returnvalue
end

function vexalarm.testmode.collectSpells()
	vexalarm_Testmode_Spells = {}
	vexalarm_Testmode_Frames = 0
	for key in pairs(vexalarm.defaults.spells) do
		for frame in pairs(vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"]) do
			if vexalarm_Testmode_Spells[frame] == nil then
				vexalarm_Testmode_Spells[frame] = {}
				vexalarm_Testmode_Frames = vexalarm_Testmode_Frames + 1
			end
			
			local check = false
			
			if vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["spellsToCheck"]["useSpellProfile"] and vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["spellsToCheck"]["spellProfile"]] ~= nil then
				if vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["spellsToCheck"]["spellProfile"]][key] ~= nil then
					for i=1,4 do
						if vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["spellsToCheck"]["spellProfile"]][key][i] then
							check = true
						end
					end
				end
			elseif not(vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["spellsToCheck"]["useSpellProfile"]) then
				if vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spells"][key] ~= nil then
					for i=1,4 do
						if vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spells"][key][i] then
							check = true
						end
					end
				end
			end
			
			if check then
				vexalarm_Testmode_Spells[frame][#vexalarm_Testmode_Spells[frame]+1] = key
			end
		end
	end
end

function vexalarm.testmode.postWarning()
	if vexalarm.testmode.activated then
		local names = {"DaKiller", "UberPvpler", "KingCarl", "OmfgRoflLol", "TreeHugger", "Sporty", "Darlene", "Karin", "Dave", "Don", "Wulf", "Talric", "Gonzalez", "Sarisse", "Toren"}
		local caster = names[math.random(1,#names)]
		local target = caster
		
		while target == caster do
			target = names[math.random(1,#names)]
		end
		
		local rndFrame = vexalarm.testmode.getRndFrame()
	
		if rndFrame ~= nil then
			local spellid = vexalarm.testmode.getRndSpell(rndFrame)
			if spellid ~= nil then
				for frame in pairs(vexalarm_Testmode_Spells) do
					local alarmtype = vexalarm.defaults.spells[spellid][6]
					local spellname = select(1, GetSpellInfo(tonumber(spellid)))
					local eventchar = ""
					local lossEvent = false
					if vexalarm.defaults.spells[spellid][6][7] ~= nil then
						eventchar = "SPELL_SUMMON"
						lossEvent = true
					elseif vexalarm.defaults.spells[spellid][6] == "buffWOtarget" or vexalarm.defaults.spells[spellid][6] == "buffWtarget" or vexalarm.defaults.spells[spellid][6] == "grpbuff" then
						eventchar = "SPELL_AURA_APPLIED"
						lossEvent = true
					else
						eventchar = "SPELL_CAST_SUCCESS"
					end
					
					local alarmtype = vexalarm.warning.validate(spellid, caster, eventchar, frame)
					if(alarmtype ~="" and alarmtype ~="dejavue") then
						vexalarm.warning.postWarning(alarmtype, spellname, spellid, caster, target, true, frame)
						if lossEvent then
							vexalarm.testmode.delayTimerFade(spellid, caster, target)
						end
					end
				end
			end
		end
	end
end

function vexalarm.testmode.postWarningFade(spellid, caster, target)
	if vexalarm.testmode.activated then
		for frame in pairs(vexalarm_Testmode_Spells) do
			local alarmtype = vexalarm.defaults.spells[spellid][6]
			local spellname = select(1, GetSpellInfo(tonumber(spellid)))
			local eventchar = ""
			if vexalarm.defaults.spells[spellid][6][7] ~= nil then
				vexalarm.warning.postWarning(alarmtype, spellname, spellid, caster, target, false, frame)
			elseif vexalarm.defaults.spells[spellid][6] == "buffWOtarget" or vexalarm.defaults.spells[spellid][6] == "buffWtarget" or vexalarm.defaults.spells[spellid][6] == "grpbuff" then
				local alarmtype = vexalarm.warning.validate(spellid, caster, "SPELL_AURA_REMOVED", frame)
				if(alarmtype ~="" and alarmtype ~="dejavue") then
					vexalarm.warning.postWarning(alarmtype, spellname, spellid, caster, target, false, frame)				
				end
			end
		end
	end
end

function vexalarm.testmode.delayTimer()
	if vexalarm.testmode.activated then
		vexalarm.testmode.handler(false)
		local test_aniGRP = vexalarm_event_frame:CreateAnimationGroup("vexalarm.testmode.delayTimer")
		test_aniGRP:SetLooping("NONE")
		local test_ani = test_aniGRP:CreateAnimation("Scale")
		test_ani:SetOrder(1)
		test_ani:SetDuration(0)
		test_ani:SetScale(1,1)
		test_ani:SetEndDelay(1)
		test_aniGRP:SetScript("OnFinished", function () vexalarm.testmode.handler(true) end)
		test_aniGRP:Play()
	end
end

function vexalarm.testmode.delayTimerFade(spellid, caster, target)
	if vexalarm.testmode.activated then
		local test_aniGRP = vexalarm_event_frame:CreateAnimationGroup("vexalarm.testmode.delayTimerFade")
		test_aniGRP:SetLooping("NONE")
		local test_ani = test_aniGRP:CreateAnimation("Scale")
		test_ani:SetOrder(1)
		test_ani:SetDuration(0)
		test_ani:SetScale(1,1)
		test_ani:SetEndDelay(5)
		test_aniGRP:SetScript("OnFinished", function () vexalarm.testmode.postWarningFade(spellid, caster, target) end)
		test_aniGRP:Play()
	end
end

function vexalarm.testmode.animation()
	if vexalarm.testmode.activated then
		local test_aniGRP = vexalarm_event_frame:CreateAnimationGroup("vexalarm.testmode.animation")
		test_aniGRP:SetLooping("NONE")
		local test_ani = test_aniGRP:CreateAnimation("Scale")
		test_ani:SetOrder(1)
		test_ani:SetDuration(0)
		test_ani:SetScale(1,1)
		test_ani:SetEndDelay(3)
		test_aniGRP:SetScript("OnFinished", function () vexalarm.testmode.animation() vexalarm.testmode.postWarning() end)
		test_aniGRP:Play()
	end
end

function vexalarm.testmode.recolorFrame()
	if vexalarm_Testmode_newBGcolors == nil then
		vexalarm_Testmode_newBGcolors = {}
	end
	for frame in pairs(vexalarm.frames.createdFrames) do
		if vexalarm.testmode.activated then
			local bg = {math.random(), math.random(), math.random()}
			local border = {bg[1] + 0.5, bg[2] + 0.5, bg[3] + 0.5}
			if border[1] > 1 then border[1] = border[1] - 1 end
			if border[2] > 1 then border[2] = border[2] - 1 end
			if border[3] > 1 then border[3] = border[3] - 1 end
			vexalarm.frames.createdFrames[frame]:SetBackdropColor(bg[1], bg[2], bg[3], 0.5)
			vexalarm.frames.createdFrames[frame]:SetBackdropBorderColor(border[1], border[2], border[3], 0.5)
			vexalarm_Testmode_newBGcolors[frame] = {}
			vexalarm_Testmode_newBGcolors[frame]["bg"] = bg
			vexalarm_Testmode_newBGcolors[frame]["border"] = border
		else
			vexalarm.frames.createdFrames[frame]:SetBackdropColor(
				vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["bg"]["color"]["r"],
				vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["bg"]["color"]["g"],
				vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["bg"]["color"]["b"],
				vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["bg"]["color"]["a"])
				
			vexalarm.frames.createdFrames[frame]:SetBackdropBorderColor(
				vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["border"]["color"]["r"],
				vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["border"]["color"]["g"],
				vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["border"]["color"]["b"],
				vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["border"]["color"]["a"])
		end
	end
end

function vexalarm.testmode.toggleFontframes()
	if vexalarm_Testmode_FontFrames == nil then
		vexalarm_Testmode_FontFrames = {}
	end
	vexalarm.testmode.deleteFontframes()
	if vexalarm.testmode.activated then
		vexalarm.testmode.createAllFontframes()
	end
end

function vexalarm.testmode.deleteFontframes()
	for frame in pairs(vexalarm_Testmode_FontFrames) do
		if vexalarm_Testmode_FontFrames[frame] ~= nil then
			for fontFrame in pairs(vexalarm_Testmode_FontFrames[frame]) do
				if vexalarm_Testmode_FontFrames[frame] ~= nil then
					vexalarm_Testmode_FontFrames[frame][fontFrame]:Hide()
					vexalarm_Testmode_FontFrames[frame][fontFrame] = nil
				end
			end
		end
	end
end

function vexalarm.testmode.createAllFontframes()
	for frame in pairs(vexalarm.frames.createdFrames) do
		vexalarm_Testmode_FontFrames[frame] = {}
		if vexalarm.frames.createdFrames[frame] ~= nil then
			vexalarm.testmode.createFontframes(frame)
		end
	end
end

function vexalarm.testmode.createFontframes(frame)
	if vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame] ~= nil then
		for i=1, vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["maxEvents"] do
			vexalarm.testmode.createSingleFontframe(frame, i)
		end
	end
end

function vexalarm.testmode.createSingleFontframe(frame, position)
	local newframe = CreateFrame("Frame", nil, vexalarm.frames.createdFrames[frame])
	newframe:SetBackdrop({bgFile="Interface\\Buttons\\WHITE8X8", tile=false, edgeFile="Interface\\Buttons\\WHITE8X8", edgeSize=1})
		
	local bg = {math.random(), math.random(), math.random()}
	local border = {bg[1] + 0.5, bg[2] + 0.5, bg[3] + 0.5}
	if border[1] > 1 then border[1] = border[1] - 1 end
	if border[2] > 1 then border[2] = border[2] - 1 end
	if border[3] > 1 then border[3] = border[3] - 1 end
	newframe:SetBackdropColor(bg[1], bg[2], bg[3], 0.5)
	newframe:SetBackdropBorderColor(border[1], border[2], border[3], 0.5)
	newframe:SetWidth(vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["size"]["width"]-(vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["position"]["warnings"]["x"]*2))
	newframe:SetHeight(vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["text"]["size"])
	newframe:ClearAllPoints()
	if vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["scrolling"]["downwards"] then
		newframe:SetPoint("BOTTOMLEFT", vexalarm.frames.createdFrames[frame], "BOTTOMLEFT",
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["position"]["warnings"]["x"],
									(vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["position"]["warnings"]["spacing"]*position)-vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["position"]["warnings"]["y"])

	else
		newframe:SetPoint("TOPLEFT", vexalarm.frames.createdFrames[frame], "TOPLEFT",
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["position"]["warnings"]["x"],
									(-vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["position"]["warnings"]["spacing"]*position)+vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["position"]["warnings"]["y"])
	end		
	newframe:Show()
	
	vexalarm_Testmode_FontFrames[frame][tostring(position)] = newframe
end