function vexalarm.options.frame.content.panel()
	local temp = {
		type = "group",
		args = {
			grptestmode = {
				name = "Testmode",
				order=1, type ="group", dialogInline = true,
				args = {
					testmode = {
						name = "Activate",
						order=1, type = "toggle", width="double",
						set = function(info,val) vexalarm.testmode.handler(val) end,
						get = function() return vexalarm.testmode.activated end,
						},
					testmodeinfo = {name = "- Simulates Event outputs. The spell/spell-profile adjustments\nfor the frames are still active.\n- Frames become movable\n- Frames and Outputpositions become recolored", type = "description", order=2, width="double"},
					edit = {name ='\nAny changes will be saved in profile: "|CFF008000'..vexalarm_SV_data["profile"]..'|r"', type = "description", order=5, width="normal"},
					},
				},
			frame_space_testmode = {name ="\n", type = "description", order=2},
			}
		}
	local framelist = {}
	for key in pairs(vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"]) do
		framelist[#framelist+1] = key
	end
	table.sort(framelist, function (a,b) return a<b end)
	
	local counter = 0
	for i,frame in pairs(framelist) do
		counter = counter +1
		local framegrp = {
			type = "group",
			name = "Frame: "..frame, dialogInline = true,
			order = counter*50,
			args = {
				spellprofile = {
					name = "Existings spell-profiles",
					order=2, type = "select", style = "dropdown", width="double",
					values = vexalarm.options.spells.profiles.getList(false, false),
					set = function(self,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["spellsToCheck"]["spellProfile"] = val vexalarm.initialize.core(true) vexalarm.testmode.delayTimer() end,
					get = function() return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["spellsToCheck"]["spellProfile"] end,
					},
				},
			}
		temp.args[frame] = framegrp
		temp.args[frame.."space"] = {name =" ", type = "description", order=counter*5+1}
	end
	
	if counter == 0 then
		local temp = {
			type = "group",
			args = {
				info = {name = "No frame created", type = "description", order=15},
				}
			}
	end
	
	return temp
end
