function vexalarm.options.frame.settings.panel()
	vexalarm.options.frame.settings.setCurrentFrame()
	
	local frame = vexalarm.options.frame.settings.currentFrame
	
	return {
		type = "group",
		args = {
			grptestmode = {
				name = "Testmode",
				order=1, type ="group", dialogInline = true,
				args = {
					testmode = {
						name = "Activate",
						order=1, type = "toggle", width="double",
						set = function(info,val) vexalarm.testmode.handler(val) end,
						get = function() return vexalarm.testmode.activated end,
						},
					testmodeinfo = {name = "- Simulates Event outputs. The spell/spell-profile adjustments\nfor the frames are still active.\n- Frames become movable\n- Frames and Outputpositions become recolored", type = "description", order=2, width="double"},
					edit = {name ='\nAny changes will be saved in profile: "|CFF008000'..vexalarm_SV_data["profile"]..'|r"', type = "description", order=5, width="normal"},
					},
				},
			frame_space_testmode = {name ="\n", type = "description", order=2},
			
			grpoptiontabs = {
				name = "Toggle Option Tabs",
				order=3, type ="group", dialogInline = true,
				args = {
					Manager = {
						name = "Create / Delete",
						order=1, type = "execute", width="normal",
						func = function(info,val) vexalarm.options.frame.settings.toggleTag("manager") vexalarm.initialize.core(true) end,
						},
					Design = {
						name = "Frame",
						order=3, type = "execute", width="half",
						func = function(info,val) vexalarm.options.frame.settings.toggleTag("design") vexalarm.initialize.core(true) end,
						},
					Text = {
						name = "Outputs",
						order=4, type = "execute", width="half",
						func = function(info,val) vexalarm.options.frame.settings.toggleTag("text") vexalarm.initialize.core(true) end,
						},
					Sounds = {
						name = "Sounds",
						order=5, type = "execute", width="half",
						func = function(info,val) vexalarm.options.frame.settings.toggleTag("sounds") vexalarm.initialize.core(true) end,
						},
					Show = {
						name = "Show",
						order=6, type = "execute", width="half",
						func = function(info,val) vexalarm.options.frame.settings.toggleTag("show") vexalarm.initialize.core(true) end,
						},
					},
				},
			spaceoptiontabs = {name =" ", type = "description", order=4},
			
			manager = {
				name = "Create / Delete",
				order=10, type ="group", dialogInline = true, hidden = not(vexalarm.options.frame.settings.openTab["manager"]),
				args = {
					grpadd = {
						name = "Create Frame",
						order=1, type ="group", dialogInline = true,
						args = {
							frame_new = {
								name = "Name",
								order=1, type = "input", multiline = false, width = "double",
								set = function(info,val) vexalarm.options.frame.settings.name = val vexalarm.initialize.core(true) end,
								get = function() return vexalarm.options.frame.settings.name end,
								},
							space1 = {name = "", type = "description", order=2},
							frame_new_add = {
								name = "Create a new Frame",
								order=5, type = "execute",
								disabled = not(vexalarm.options.general.checkName(vexalarm.options.frame.settings.name)),
								func = function(info,val) vexalarm.options.frame.settings.createFrame() vexalarm.initialize.core(true) vexalarm.testmode.delayTimer() end,
								confirm = vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][vexalarm.options.frame.settings.name]~= nil,
								confirmText = "A frame with that name allready exists. Do you want to overwrite it ?",
								},
							space2 = {name = "", type = "description", order=10},
							frame_new_clone = {
								name = "Create clone of",
								order=11, type = "execute",
								disabled = not(vexalarm.options.general.checkName(vexalarm.options.frame.settings.name)),
								func = function(info,val) vexalarm.options.frame.settings.createClone() vexalarm.initialize.core(true) vexalarm.testmode.delayTimer() end,
								confirm = vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][vexalarm.options.frame.settings.name]~= nil,
								confirmText = "A frame with that name allready exists. Do you want to overwrite it ?",
								},
							frame = {
								name = "Existing Frames",
								order=12, type = "select", style = "dropdown",
								values =  vexalarm.options.frame.settings.getList(),
								disabled = not(vexalarm.options.general.checkName(vexalarm.options.frame.settings.name)),
								set = function(self,key)
									vexalarm.options.frame.settings.currentFrame = key
									vexalarm.initialize.core(true)
									end,
								get = function() return vexalarm.options.frame.settings.currentFrame end,
								},
							status = {name = vexalarm.options.frame.settings.statusMsg["create"], type = "description", order=15},
							},
						},
					frame_space2 = {name =" ", type = "description", order=2},
					grpdelete = {
						name = "Delete / Rename",
						order=3, type ="group", dialogInline = true,
						args = {
							frame = {
								name = "Existing Frames",
								order=1, type = "select", style = "dropdown",
								values =  vexalarm.options.frame.settings.getList(),
								set = function(self,key)
									vexalarm.options.frame.settings.currentFrame = key
									vexalarm.options.frame.settings.newName = key
									vexalarm.initialize.core(true)
									end,
								get = function() return vexalarm.options.frame.settings.currentFrame end,
								},
							space2 = {name ="", type = "description", width="normal", order=3},
							delete = {
								name = "delete",
								order=5, type = "execute",
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								func = function(info,val) vexalarm.options.frame.settings.deleteFrame() vexalarm.initialize.core(true) vexalarm.testmode.delayTimer() end,
								confirm = true,
								confirmText = "Do you really want to delete this frame?",
								},
							status = {name = vexalarm.options.frame.settings.statusMsg["delete"], type = "description", order=6},
							newname = {
								name = "New name",
								order=11, type = "input", multiline = false, width="double",
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(info,val) vexalarm.options.frame.settings.newName = val vexalarm.initialize.core(true) end,
								get = function() return vexalarm.options.frame.settings.newName end,
								},
							changename = {
								name = "change Name",
								order=12, type = "execute",
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame) or vexalarm.options.frame.settings.newName=="",
								func = function(info,val) vexalarm.options.frame.settings.rename() vexalarm.initialize.core(true) vexalarm.testmode.delayTimer() end,
								confirm = vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][vexalarm.options.frame.settings.newName]~= nil,
								confirmText = "A frame with the new name allready exists. Do you want to overwrite it ?",
								},
							status2 = {name = vexalarm.options.frame.settings.statusMsg["rename"], type = "description", order=13},
							},
						},
					},
				},
				
				
			
			design = {
				name = "Frame",
				order=30, type ="group", dialogInline = true, hidden = not(vexalarm.options.frame.settings.openTab["design"]),
				args = {
					frame = {
						name = "Frame to edit",
						order=1, type = "select", style = "dropdown",
						values =  vexalarm.options.frame.settings.getList(),
						set = function(self,key)
							vexalarm.options.frame.settings.currentFrame = key
							vexalarm.options.frame.settings.newName = key
							vexalarm.initialize.core(true)
							end,
						get = function() return vexalarm.options.frame.settings.currentFrame end,
						},	
					space1 = {name =" ", type = "description", order=2},
					grppos = {
						name = "Position and Size",
						order=10, type ="group", dialogInline = true,
						args = {
							framewidth = {
								name = "width",
								order=1, type = "range",
								step = 1, min = 1, max = 2000,
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["size"]["width"]=val vexalarm.initialize.core(true) end,
								get = function() return vexalarm.options.frame.settings.getDesigndata("width") end
								},
							frameheight = {
								name = "height",
								order=2, type = "range",
								step = 1, min = 1, max = 2000,
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["size"]["height"]=val vexalarm.initialize.core(true) end,
								get = function() return vexalarm.options.frame.settings.getDesigndata("height") end
								},
							space1 = {name =" ", type = "description", order=3},
							frame_pos_x = {
								name = "X Position",
								order=10, type = "range",
								step = 1, min = -2000, max = 2000,
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["position"]["frame"]["x"]=val vexalarm.initialize.core(true) end,
								get = function() return vexalarm.options.frame.settings.getDesigndata("x") end
								},
							frame_pos_y = {
								name = "Y Position",
								order=11, type = "range",
								step = 1, min = -2000, max = 2000,
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["position"]["frame"]["y"]=val vexalarm.initialize.core(true) end,
								get = function() return vexalarm.options.frame.settings.getDesigndata("y") end
								},
							space2 = {name =" ", type = "description", order=12},
							frameanchor = {
								name = "Anchor Frame",
								order=20, type = "select", style = "dropdown",
								values = {
									["CENTER"]="Center",
									["BOTTOM"]="Bottom",
									["TOP"]="Top",
									["LEFT"]="Left",
									["RIGHT"]="Right",
									["BOTTOMLEFT"]="Bottom Left",
									["BOTTOMRIGHT"]="Bottom Right",
									["TOPLEFT"]="Top Left",
									["TOPRIGHT"]="Top Right"},
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(self,key) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["position"]["frame"]["anchor"]=key vexalarm.initialize.core(true) end,
								get = function() return vexalarm.options.frame.settings.getDesigndata("anchor1") end,
								},
							screenanchor = {
								name = "Anchor Screen",
								order=21, type = "select", style = "dropdown",
								values = {
									["CENTER"]="Center",
									["BOTTOM"]="Bottom",
									["TOP"]="Top",
									["LEFT"]="Left",
									["RIGHT"]="Right",
									["BOTTOMLEFT"]="Bottom Left",
									["BOTTOMRIGHT"]="Bottom Right",
									["TOPLEFT"]="Top Left",
									["TOPRIGHT"]="Top Right"},
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(self,key) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["position"]["frame"]["frameanchor"]=key vexalarm.initialize.core(true) end,
								get = function() return vexalarm.options.frame.settings.getDesigndata("anchor2") end,
								},
							},
						},
					frame_space1 = {name ="\n", type = "description", order=11},
						
					grpbg = {
						name = "Background",
						order=12, type ="group", dialogInline = true,
						args = {
							framebackdrop = {
								name = "Texture",
								order=1, type = "select",
								dialogControl = "LSM30_Background",
								values = vexalarm.LSM:HashTable("background"),
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(self,key) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["bg"]["texture"]=key vexalarm.initialize.core(true) end,
								get = function() return vexalarm.options.frame.settings.getDesigndata("bgtexture") end,
								},
							bg_space = {name =" ", type = "description", order=2},
							framebgcolor = {
								name = "Color",
								order=3, type = "color", hasAlpha = false, width="double",
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(info,r,g,b,a)
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["bg"]["color"]["r"]=r
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["bg"]["color"]["g"]=g
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["bg"]["color"]["b"]=b
									vexalarm.testmode.recolor = true
									vexalarm.initialize.core(true) end,
								get = function() return
									vexalarm.options.frame.settings.getDesigndata("bgcolor", "r"),
									vexalarm.options.frame.settings.getDesigndata("bgcolor", "g"),
									vexalarm.options.frame.settings.getDesigndata("bgcolor", "b") end,
								},
							framebgopacity = {
								name = "Opacity %",
								order=4, type = "range",
								step = 5, min = 0, max = 100,
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(info,val)
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["bg"]["color"]["a"]=val/100
									vexalarm.testmode.recolor = true
									vexalarm.initialize.core(true) end,
								get = function() return vexalarm.options.frame.settings.getDesigndata("bgcolor", "a")*100 end
								},
							},
						},
					frame_space2 = {name ="\n", type = "description", order=13},
						
					grpborder = {
						name = "Border",
						order=14, type ="group", dialogInline = true,
						args = {
							bordertexture = {
								name = "Texture",
								order=1, type = "select",
								dialogControl = "LSM30_Border",
								values = vexalarm.LSM:HashTable("border"),
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(self,key)
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["border"]["texture"]=key
									vexalarm.initialize.core(true) end,
								get = function() return vexalarm.options.frame.settings.getDesigndata("bordert") end,
								},
							space1 = {name =" ", width="normal", type = "description", order=2},
							bordersize = {
								name = "Size",
								order=10, type = "range",
								step = 1, min = 0, max = 100,
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["border"]["size"]=val vexalarm.initialize.core(true) end,
								get = function() return vexalarm.options.frame.settings.getDesigndata("borders") end,
								},
							space2 = {name =" ", type = "description", order=11},
							bordercolor = {
								name = "Color",
								order=20, type = "color", hasAlpha = false, width="double",
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(info,r,g,b,a)
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["border"]["color"]["r"]=r
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["border"]["color"]["g"]=g
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["border"]["color"]["b"]=b
									vexalarm.testmode.recolor = true
									vexalarm.initialize.core(true) end,
								get = function() return
									vexalarm.options.frame.settings.getDesigndata("borderc", "r"),
									vexalarm.options.frame.settings.getDesigndata("borderc", "g"),
									vexalarm.options.frame.settings.getDesigndata("borderc", "b") end,
								},
							frameborderopacity = {
								name = "Opacity %",
								order=21, type = "range",
								step = 5, min = 0, max = 100,
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(info,val)
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["border"]["color"]["a"]=val/100
									vexalarm.testmode.recolor = true
									vexalarm.initialize.core(true) end,
								get = function() return vexalarm.options.frame.settings.getDesigndata("borderc", "a")*100 end
								},
							}
						}
					},
				},
				
				
			
			text = {
				name = "Output",
				order=40, type ="group", dialogInline = true, hidden = not(vexalarm.options.frame.settings.openTab["text"]),
				args = {
					frame = {
						name = "Frame to edit",
						order=1, type = "select", style = "dropdown",
						values =  vexalarm.options.frame.settings.getList(),
						set = function(self,key)
							vexalarm.options.frame.settings.currentFrame = key
							vexalarm.options.frame.settings.newName = key
							vexalarm.initialize.core(true)
							end,
						get = function() return vexalarm.options.frame.settings.currentFrame end,
						},	
					frame_space = {name =" ", type = "description", order=2},
					grptextformat = {
						name = "Format",
						order=3, type ="group", dialogInline = true,
						args = {
							textfont = {
								name = "Font",
								order=1, type = "select",
								dialogControl = "LSM30_Font",
								values = vexalarm.LSM:HashTable("font"),
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(self,key) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["text"]["font"]=key end,
								get = function() return vexalarm.options.frame.settings.getData("font") end,
								},
							textsize = {
								name = "Size",
								order=2, type = "range",
								step = 1, min = 6, max = 20,
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["text"]["size"]=val end,
								get = function() return vexalarm.options.frame.settings.getData("size") end,
								},
							fontalign = {
								name = "Align",
								order=3, type = "select", style = "dropdown",
								values = {["LEFT"]="Left",
										["CENTER"]="Center",
										["RIGHT"]="Right"},
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(self,key) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["text"]["align"]=key end,
								get = function() return vexalarm.options.frame.settings.getData("align") end,
								},
							fontoutline = {
								name = "Effect",
								order=3, type = "select", style = "dropdown",
								values = {["MONOCHROME"]="Monochrome",
											["OUTLINE"]="Outline",
											[""]="None",
											["THICKOUTLINE"]="Thickoutline"},
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(self,key) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["text"]["outline"]=key end,
								get = function() return vexalarm.options.frame.settings.getData("outline") end,
								},
							},
						},
					frame_spacefont = {name ="\n", type = "description", order=4},
					grpevents = {
						name = "Position",
						order=5, type ="group", dialogInline = true,
						args = {
							alarmx = {
								name = "X Distance",
								desc = "Distance from the right and left side of the frame to the text",
								order=1, type = "range",
								step = 1, min = 1, max = 100,
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["position"]["warnings"]["x"]=val vexalarm.testmode.toggleFontFrames() end,
								get = function() return vexalarm.options.frame.settings.getData("alarmx") end,
								},
							alarmy = {
								name = "Y Distance",
								desc = "Distance from the bottom or top of the frame to the first output",
								order=2, type = "range",
								step = 1, min = -100, max = 100,
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["position"]["warnings"]["y"]=val vexalarm.testmode.toggleFontFrames() end,
								get = function() return vexalarm.options.frame.settings.getData("alarmy") end,
								},
							space1 = {name =" ", type = "description", order=3},
							alarmspacing = {
								name = "Separation",
								desc = "Distance between the outputs",
								order=10, type = "range",
								step = 1, min = 1, max = 100,
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["position"]["warnings"]["spacing"]=val vexalarm.testmode.toggleFontFrames() end,
								get = function() return vexalarm.options.frame.settings.getData("alarms") end,
								},
							alarmcount = {
								name = "Maximum shown events",
								order=11, type = "range",
								step = 1, min = 1, max = 20,
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["maxEvents"]=val vexalarm.testmode.toggleFontFrames() end,
								get = function() return vexalarm.options.frame.settings.getData("maxevents") end,
								},
							alarmdownwars = {
								name = "Arrange outputs upwars, instead of downwards",
								order=12, type = "toggle", width="full",
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["scrolling"]["downwards"]=val vexalarm.testmode.toggleFontFrames() end,
								get = function() return vexalarm.options.frame.settings.getData("scrolldown") end,
								},
							},
						},
					frame_space1 = {name ="\n", type = "description", order=6},
					
					grptextcolors = {
						name = "Colors",
						order=7, type ="group", dialogInline = true,
						args = {
							statuscolor1 = {
								name = "[status_sc] active",
								order=1, type = "color", width="",
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(info,r,g,b)
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["tagColors"]["active"]["HEX"] = vexalarm.colorize.decToHex(r,g,b)
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["tagColors"]["active"]["r"] = r
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["tagColors"]["active"]["g"] = g
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["tagColors"]["active"]["b"] = b end,
								get = function() return
									vexalarm.options.frame.settings.getData("status_sca", "r"),
									vexalarm.options.frame.settings.getData("status_sca", "g"),
									vexalarm.options.frame.settings.getData("status_sca", "b") end,
								},
							statusmsgcolor1 = {
								name = "text color for buff gained/spell casted",
								order=2, type = "color", width="double",
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(info,r,g,b,a)
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["text"]["color"]["active"]["r"] = r
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["text"]["color"]["active"]["g"] = g
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["text"]["color"]["active"]["b"] = b end,
								get = function() return
									vexalarm.options.frame.settings.getData("colorg", "r"),
									vexalarm.options.frame.settings.getData("colorg", "g"),
									vexalarm.options.frame.settings.getData("colorg", "b")end,
								},
							statuscolor2 = {
								name = "[status_sc] inactive",
								order=3, type = "color",
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(info,r,g,b)
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["tagColors"]["inactive"]["HEX"] = vexalarm.colorize.decToHex(r,g,b)
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["tagColors"]["inactive"]["r"] = r
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["tagColors"]["inactive"]["g"] = g
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["tagColors"]["inactive"]["b"] = b end,
								get = function() return
									vexalarm.options.frame.settings.getData("status_sci", "r"),
									vexalarm.options.frame.settings.getData("status_sci", "g"),
									vexalarm.options.frame.settings.getData("status_sci", "b") end,
								},
							statusmsgcolor2 = {
								name = "text color for buff lost",
								order=4, type = "color", width="double",
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(info,r,g,b,a)
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["text"]["color"]["inactive"]["r"] = r
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["text"]["color"]["inactive"]["g"] = g
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["text"]["color"]["inactive"]["b"] = b end,
								get = function() return
									vexalarm.options.frame.settings.getData("colorf", "r"),
									vexalarm.options.frame.settings.getData("colorf", "g"),
									vexalarm.options.frame.settings.getData("colorf", "b") end,
								},
							frame_textspace3 = {name ="\n\n", type = "description", order=5},
							
							castercolor = {
								name = "[caster_sc]",
								order=6, type = "color", width="full",
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(info,r,g,b)
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["tagColors"]["caster_sc"]["HEX"] = vexalarm.colorize.decToHex(r,g,b)
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["tagColors"]["caster_sc"]["r"] = r
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["tagColors"]["caster_sc"]["g"] = g
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["tagColors"]["caster_sc"]["b"] = b end,
								get = function() return
									vexalarm.options.frame.settings.getData("caster_sc", "r"),
									vexalarm.options.frame.settings.getData("caster_sc", "g"),
									vexalarm.options.frame.settings.getData("caster_sc", "b") end,
								},
							targetcolor = {
								name = "[target_sc]",
								order=7, type = "color", width="full",
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(info,r,g,b)
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["tagColors"]["target_sc"]["HEX"] = vexalarm.colorize.decToHex(r,g,b)
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["tagColors"]["target_sc"]["r"] = r
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["tagColors"]["target_sc"]["g"] = g
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["tagColors"]["target_sc"]["b"] = b end,
								get = function() return
									vexalarm.options.frame.settings.getData("target_sc", "r"),
									vexalarm.options.frame.settings.getData("target_sc", "g"),
									vexalarm.options.frame.settings.getData("target_sc", "b") end,
								},
							spellcolor = {
								name = "[spell_sc]",
								order=8, type = "color", width="full",
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(info,r,g,b)
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["tagColors"]["spell_sc"]["HEX"] = vexalarm.colorize.decToHex(r,g,b)
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["tagColors"]["spell_sc"]["r"] = r
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["tagColors"]["spell_sc"]["g"] = g
									vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["tagColors"]["spell_sc"]["b"] = b end,
								get = function() return
									vexalarm.options.frame.settings.getData("spell_sc", "r"),
									vexalarm.options.frame.settings.getData("spell_sc", "g"),
									vexalarm.options.frame.settings.getData("spell_sc", "b") end,
								},
						
							},
						},
					frame_space2 = {name ="\n", type = "description", order=8},
					
					grptimedata = {
						name = "Timedata",
						order=9, type ="group", dialogInline = true,
						args = {
							allowvanish = {
								name = "Activate 'fade-out'-effect",
								order=1, type = "toggle", width="full",
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["fadeOutEffect"]["enable"]=val end,
								get = function() return vexalarm.options.frame.settings.getData("allowvanish") end,
								},
							timedataspace = {name =" ", type = "description", order=2},
							alarmshowtime = {
								name = "Duration: message shown",
								order=2, type = "range",
								step = 1, min = 1, max = 10,
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["fadeOutEffect"]["durationShow"]=val end,
								get = function() return vexalarm.options.frame.settings.getData("tdshow") end,
								},
							alarmvanishtime = {
								name = "Duration: 'fade-out'-effect",
								order=3, type = "range",
								step = 1, min = 1, max = 10,
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["fadeOutEffect"]["durationVanish"]=val end,
								get = function() return vexalarm.options.frame.settings.getData("tdvanish") end,
								},
							},
						},
					frame_space3 = {name ="\n", type = "description", order=10},
					
					grpdeirmode = {
						name = "'DEIR'-Mode",
						order=11, type ="group", dialogInline = true,
						args = {
							moveuptext = {name ="In 'DEIR'-mode (Dead Events in Idle Rotatestate) the events don't move up anymore when an event-message which is displayed above them expired. They stay at their location where they are first shown.", type = "description", order=123, fontSize="medium"},
							allowmoveup = {
								name = "Activate",
								order=123, type = "toggle", width="full",
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["scrolling"]["enable"]=not(val) end,
								get = function() return vexalarm.options.frame.settings.getData("allowscrolling") end,
								},
							}
						}
					},
				},
				
				
			
			sounds = {
				name = "Sounds",
				order=50, type ="group", dialogInline = true, hidden = not(vexalarm.options.frame.settings.openTab["sounds"]),
				args = {
					frame = {
						name = "Frame to edit",
						order=1, type = "select", style = "dropdown",
						values =  vexalarm.options.frame.settings.getList(),
						set = function(self,key)
							vexalarm.options.frame.settings.currentFrame = key
							vexalarm.options.frame.settings.newName = key
							vexalarm.initialize.core(true)
							end,
						get = function() return vexalarm.options.frame.settings.currentFrame end,
						},	
					space1 = {name =" ", type = "description", order=2},
					grpallow = {
						name = "General Settings",
						order=10, type ="group", dialogInline = true,
						args = {
							allowsounds = {
								name = "Allow Sounds",
								order=1, type = "toggle",
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["sounds"]["enable"]=val end,
								get = function() return vexalarm.options.frame.settings.getSoundData("allow") end,
								},
							},
						},
					space2 = {name ="\n", type = "description", order=11},
					grpactive = {
						name = "Buff gained",
						order=20, type ="group", dialogInline = true,
						args = {
							buff_activesound = {
								name = "Sound",
								order=11, type = "select",
								dialogControl = "LSM30_Sound",
								values = vexalarm.LSM:HashTable("sound"),
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(self,key) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["sounds"]["buffApplied"]["file"] = key end,
								get = function() return vexalarm.options.frame.settings.getSoundData("file1") end,
								},
							buff_activesoundchannel = {
								name = "Channel",
								order=12, type = "select", style = "dropdown",
								values = {["Master"]="Master", ["SFX"]="SFX", ["Ambience"]="Ambience", ["Music"]="Music"},
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(self,key) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["sounds"]["buffApplied"]["channel"] = key  end,
								get = function() return vexalarm.options.frame.settings.getSoundData("channel1") end,
								},
							},
						},
					space3 = {name ="\n", type = "description", order=21},
					grpinactive = {
						name = "Buff lost",
						order=30, type ="group", dialogInline = true,
						args = {
							buff_inactivesound = {
								name = "Sound",
								order=21, type = "select",
								dialogControl = "LSM30_Sound",
								values = vexalarm.LSM:HashTable("sound"),
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(self,key) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["sounds"]["buffFade"]["file"] = key end,
								get = function() return vexalarm.options.frame.settings.getSoundData("file2") end,
								},
							buff_inactivesoundchannel = {
								name = "Channel",
								order=22, type = "select", style = "dropdown",
								values = {["Master"]="Master", ["SFX"]="SFX", ["Ambience"]="Ambience", ["Music"]="Music"},
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(self,key) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["sounds"]["buffFade"]["channel"] = key end,
								get = function() return vexalarm.options.frame.settings.getSoundData("channel2") end,
								},
							},
						},
					space4 = {name ="\n", type = "description", order=31},
					grpcast = {
						name = "Spell without buff casted",
						order=40, type ="group", dialogInline = true,
						args = {
							inactivesound = {
								name = "Sound",
								order=21, type = "select",
								dialogControl = "LSM30_Sound",
								values = vexalarm.LSM:HashTable("sound"),
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(self,key) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["sounds"]["cast"]["file"] = key end,
								get = function() return vexalarm.options.frame.settings.getSoundData("file3") end,
								},
							inactivesoundchannel = {
								name = "Channel",
								order=22, type = "select", style = "dropdown",
								values = {["Master"]="Master", ["SFX"]="SFX", ["Ambience"]="Ambience", ["Music"]="Music"},
								disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(self,key) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["sounds"]["cast"]["channel"] = key end,
								get = function() return vexalarm.options.frame.settings.getSoundData("channel3") end,
								},
							},
						},
					},
				},
				
				
			
			show = {
				name = "Show",
				order=60, type ="group", dialogInline = true, hidden = not(vexalarm.options.frame.settings.openTab["show"]),
				args = {
					frame = {
						name = "Frame to edit",
						order=1, type = "select", style = "dropdown",
						values =  vexalarm.options.frame.settings.getList(),
						set = function(self,key)
							vexalarm.options.frame.settings.currentFrame = key
							vexalarm.options.frame.settings.newName = key
							vexalarm.initialize.core(true)
							end,
						get = function() return vexalarm.options.frame.settings.currentFrame end,
						},	
					frame_space = {name =" ", type = "description", order=2},
					grpshow = {
						name = "Settings",
						order=3, type ="group", dialogInline = true,
						args = {
							infightFrame = {
								name = "Hide the frame and stop tracking spells/buffs when not infight",
								order=1, type = "toggle", width="full",
										disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(self,key) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["show"]["enableFrameOnlyInfight"]=key vexalarm.warning.checkShow() end,
								get = function() return vexalarm.options.frame.settings.getShowData("showFrameonlyinfight") end,
								},
							soace = {name =" ", type = "description", order=2},
							infight = {
								name = "Only track spells/buffs when infight",
								order=10, type = "toggle", width="full",
										disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(self,key) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["show"]["activateCheckOnlyInfight"]=key vexalarm.warning.checkShow() end,
								get = function() return vexalarm.options.frame.settings.getShowData("showonlyinfight") end,
								},
							grp = {
								name = "Don't track spells/buffs from non-grp and non-raid members",
								order=11, type = "toggle", width="full",
										disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(self,key) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["show"]["showGrpMembersOnly"]=key end,
								get = function() return vexalarm.options.frame.settings.getShowData("showgrponly") end,
								},
							myspells = {
								name = "Only track spells/buffs I didn't cast myself", 
								order=12, type = "toggle", width="full",
										disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.frame.settings.getList(), vexalarm.options.frame.settings.currentFrame),
								set = function(self,key) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["show"]["mySpells"]=not(key) end,
								get = function() return not(vexalarm.options.frame.settings.getShowData("myspells")) end,
								}
							},
						},
					},
				},
			}
		}
end








