vexalarm.options.frame.settings.currentFrame = ""

vexalarm.options.frame.settings.name = ""
vexalarm.options.frame.settings.newName = ""

vexalarm.options.frame.settings.statusMsg = {
	["create"] = " ",
	["rename"] = " ",
	["delete"] = " "}

vexalarm.options.frame.settings.openTab = {
	["manager"] = false,
	["content"] = false,
	["design"] = false,
	["text"] = false,
	["sounds"] = false,
	["show"] = false,
	}

function vexalarm.options.frame.settings.feedback(category, text, error)
	for key in pairs(vexalarm.options.frame.settings.statusMsg) do
		vexalarm.options.frame.settings.statusMsg[key] = " "
	end
	if error then
		text = "|CFFC41F3B"..text.."|r"
	else
		text = "|CFF00FF00"..text.."|r"
	end
	if vexalarm.options.frame.settings.statusMsg[category] ~= nil then
		vexalarm.options.frame.settings.statusMsg[category] = text
	end
end

function vexalarm.options.frame.settings.toggleTag(tab)
	if vexalarm.options.frame.settings.openTab[tab] ~= nil then
		vexalarm.options.frame.settings.closeAllTabs()
		vexalarm.options.frame.settings.openTab[tab] = true
	end
end

function vexalarm.options.frame.settings.closeAllTabs()
	for key in pairs(vexalarm.options.frame.settings.openTab) do
		vexalarm.options.frame.settings.openTab[key] = false
	end
end

function vexalarm.options.frame.settings.setCurrentFrame()
	local changed = false
	local counter = 0
	
	for key in pairs(vexalarm.frames.createdFrames) do
		counter = counter + 1
	end
	
	if counter == 1 then
		for key in pairs(vexalarm.frames.createdFrames) do
			if not(changed) then
				vexalarm.options.frame.settings.currentFrame = key
				vexalarm.options.frame.settings.newName = key
				changed = true
			end
		end
	end
end

function vexalarm.options.frame.settings.getList(returntimer)
	local returnvalue = {}
	local timer = 0
	for key in pairs(vexalarm.frames.createdFrames) do
		returnvalue[key]=key
		timer = timer + 1
	end
	
	if timer == 0 then
		returnvalue[""] = "No frame created"
	end
	
	if returntimer then
		return timer
	else
		return returnvalue
	end
end

function vexalarm.options.frame.settings.createFrame()
	local frame = vexalarm.options.frame.settings.name
	
	if vexalarm.options.general.checkName(frame) then
		vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame] = vexalarm.lib.copyTable(vexalarm.defaults.frame["Mainframe"])
		vexalarm.options.frame.settings.name = ""
		vexalarm.options.frame.settings.feedback("create", "Frame successfully created", false)
	else
		vexalarm.options.frame.settings.feedback("create", "Couldn't create frame. Name is invalid.", true)
	end
	vexalarm.options.frame.settings.setCurrentFrame()
end

function vexalarm.options.frame.settings.createClone()
	local frame = vexalarm.options.frame.settings.name
	local clone = vexalarm.options.frame.settings.currentFrame
	
	if vexalarm.options.general.checkName(frame) and vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][clone] ~= nil then
		vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame] = vexalarm.lib.copyTable(vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][clone])
		vexalarm.options.frame.settings.name = ""
		vexalarm.options.frame.settings.feedback("create", "Frame successfully created (Clone of '"..clone.."'", false)
	elseif not(vexalarm.options.general.checkName(frame)) then
		vexalarm.options.frame.settings.feedback("create", "Couldn't clone frame. Name is invalid.", true)
	elseif vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][clone] == nil then
		vexalarm.options.frame.settings.feedback("create", "Couldn't clone from frame. Target frame doesn't exist.", true)
	end
end

function vexalarm.options.frame.settings.rename()
	local frame = vexalarm.options.frame.settings.currentFrame
	local name = vexalarm.options.frame.settings.newName
	
	if vexalarm.options.general.checkName(name) and vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]~=nil then
		vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][name] = vexalarm.lib.copyTable(vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame])
		vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame] = nil
		vexalarm.options.frame.settings.newName = name
		vexalarm.options.frame.settings.currentFrame = name
		
		vexalarm.options.frame.settings.feedback("rename", "Frame successfully renamed", false)
	elseif not(vexalarm.options.general.checkName(name)) then
		vexalarm.options.frame.settings.feedback("rename", "Couldn't rename frame. New name is invalid.", true)
	elseif vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame] == nil then
		vexalarm.options.frame.settings.feedback("rename", "Couldn't rename frame. Frame doesn't exist.", true)
	end
end

function vexalarm.options.frame.settings.deleteFrame()
	local frame = vexalarm.options.frame.settings.currentFrame	
	if vexalarm.options.general.checkName(frame) and vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]~=nil then
		vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame] = nil
		vexalarm.options.frame.settings.currentFrame = ""
		vexalarm.options.frame.settings.newName = ""
		vexalarm.options.frame.settings.feedback("delete", "Frame successfully deleted", false)
	elseif not(vexalarm.options.general.checkName(name)) then
		vexalarm.options.frame.settings.feedback("delete", "Couldn't delete frame. Name is invalid.", true)
	elseif vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame] == nil then
		vexalarm.options.frame.settings.feedback("delete", "Couldn't delete frame. Frame doesn't exist.", true)
	end
	vexalarm.options.frame.settings.setCurrentFrame()
end

function vexalarm.options.frame.settings.getDisabled(list, val)
	if list[val] == nil or val == "" then
		return true
	else
		return false
	end
end

function vexalarm.options.frame.settings.getData(data, arg)
	local frame = vexalarm.options.frame.settings.currentFrame
	if vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame] == nil then
		if arg == "r" or arg == "g" or arg == "b" or arg == "a" then
			return 0
		else
			return nil
		end
	else
		if 		data == "font" 				then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["text"]["font"]
		elseif 	data == "size"				then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["text"]["size"]
		elseif 	data == "align"				then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["text"]["align"]
		elseif 	data == "outline"			then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["text"]["outline"]
		elseif 	data == "alarmx"			then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["position"]["warnings"]["x"]
		elseif 	data == "alarmy"			then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["position"]["warnings"]["y"]
		elseif 	data == "alarms"			then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["position"]["warnings"]["spacing"]
		elseif 	data == "maxevents"			then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["maxEvents"]
		elseif 	data == "scrolldown"		then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["scrolling"]["enable"]
		
		
		elseif 	data == "status_sca"		then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["text"]["color"]["active"][arg]
		elseif 	data == "status_sci"		then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["text"]["color"]["inactive"][arg]
		
		elseif 	data == "colorg"			then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["tagColors"]["active"][arg]
		elseif 	data == "colorf"			then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["tagColors"]["inactive"][arg]
		elseif 	data == "caster_sc"			then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["tagColors"]["caster_sc"][arg]
		elseif 	data == "target_sc"			then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["tagColors"]["target_sc"][arg]
		elseif 	data == "spell_sc"			then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["tagColors"]["spell_sc"][arg]
		
		
		elseif 	data == "allowvanish"		then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["fadeOutEffect"]["enable"]
		elseif 	data == "tdshow"			then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["fadeOutEffect"]["durationShow"]
		elseif 	data == "tdvanish"			then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["fadeOutEffect"]["durationVanish"]
		elseif 	data == "allowscrolling"	then return not(vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["scrolling"]["enable"] )
		else 
			if arg == "r" or arg == "g" or arg == "b" or arg == "a" then
				return 0
			else
				return nil
			end
		end
	end
end

function vexalarm.options.frame.settings.getDesigndata(data, arg)
	local frame = vexalarm.options.frame.settings.currentFrame
	if vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame] == nil then
		if arg == "r" or arg == "g" or arg == "b" or arg == "a" then
			return 0
		else
			return nil
		end
	else
		if 		data == "width" 	then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["size"]["width"]
		elseif 	data == "height"	then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["size"]["height"]
		elseif 	data == "x"			then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["position"]["frame"]["x"]
		elseif 	data == "y"			then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["position"]["frame"]["y"]
		elseif 	data == "anchor1"	then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["position"]["frame"]["anchor"]
		elseif 	data == "anchor2"	then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["position"]["frame"]["frameanchor"]
		elseif 	data == "bgtexture"	then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["bg"]["texture"]
		elseif 	data == "bgcolor"	then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["bg"]["color"][arg]
		elseif 	data == "bordert"	then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["border"]["texture"]
		elseif 	data == "borders"	then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["border"]["size"]
		elseif 	data == "borderc"	then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["border"]["color"][arg]
		elseif 	data == "height"	then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["design"]["size"]["height"]
		else 
			if arg == "r" or arg == "g" or arg == "b" or arg == "a" then
				return 0
			else
				return nil
			end
		end
	end
end

function vexalarm.options.frame.settings.getSoundData(data)
	local frame = vexalarm.options.frame.settings.currentFrame
	if vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame] == nil then
		return nil
	else
		if 		data == "allow" 	then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["sounds"]["enable"] 
		elseif 	data == "file1"		then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["sounds"]["buffApplied"]["file"]
		elseif 	data == "file2"		then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["sounds"]["buffFade"]["file"]
		elseif 	data == "file3"		then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["sounds"]["cast"]["file"]
		elseif 	data == "channel1"	then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["sounds"]["buffApplied"]["channel"]
		elseif 	data == "channel2"	then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["sounds"]["buffFade"]["channel"]
		elseif 	data == "channel3"	then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["sounds"]["cast"]["channel"]
		else 
			return nil
		end
	end
end

function vexalarm.options.frame.settings.getShowData(data)
	local frame = vexalarm.options.frame.settings.currentFrame
	if vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame] == nil then
		return nil
	else
		if 		data == "showonlyinfight" 		then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["show"]["activateCheckOnlyInfight"] 
		elseif 	data == "showgrponly"			then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["show"]["showGrpMembersOnly"]
		elseif 	data == "showFrameonlyinfight"	then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["show"]["enableFrameOnlyInfight"]
		elseif 	data == "myspells"				then return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["show"]["mySpells"]
		else 
			return nil
		end
	end
end