
vexalarm.options.spells.profiles.current = ""
vexalarm.options.spells.profiles.name = ""
vexalarm.options.spells.profiles.newName = ""
vexalarm.options.spells.profiles.target = ""


vexalarm.options.spells.profiles.statusMsg = {
	["save"] = " ",
	["rename"] = " ",
	["load"] = " ",
	["send"] = " ",
	["saveRe"] = " "}

vexalarm.options.spells.profiles.incSP.name = ""
vexalarm.options.spells.profiles.incSP.newName = ""

function vexalarm.options.spells.profiles.feedback(category, text, error)
	for key in pairs(vexalarm.options.spells.profiles.statusMsg) do
		vexalarm.options.spells.profiles.statusMsg[key] = " "
	end
	if error then
		text = "|CFFC41F3B"..text.."|r"
	else
		text = "|CFF00FF00"..text.."|r"
	end
	if vexalarm.options.spells.profiles.statusMsg[category] ~= nil then
		vexalarm.options.spells.profiles.statusMsg[category] = text
	end
end

function vexalarm.options.spells.profiles.getList(addCurrent, showSet)
	local returnvalue = {}
	local timer = 0
	for key in pairs(vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"]) do
		if showSet then
			local framesUsed = ""
			
			for frame in pairs(vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"]) do
				if key == vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["spellsToCheck"]["spellProfile"] then
					if framesUsed ~= "" then
						framesUsed = framesUsed..", "
					end
					framesUsed = framesUsed..frame
				end
			end
			
			if vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["rw"]["spellsToCheck"]["spellProfile"] == key then
				if framesUsed ~= "" then
					framesUsed = framesUsed..", "
				end
				framesUsed = framesUsed.."RW"
			end
			
			if framesUsed == "" then
				returnvalue[key]=key
			else
				returnvalue[key]=key.." ("..framesUsed..")"
			end
		else
			returnvalue[key]=key
		end
		timer = timer + 1
	end
	if timer == 0 then
		returnvalue[""] = "No profile found"
	end
	
	-- if addCurrent then
		-- local framesUsed = ""
		-- for frame in pairs (vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"]) do
			-- if not(vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["spellsToCheck"]["useprofile"]) then
				-- if framesUsed ~= "" then
					-- framesUsed = framesUsed..", "
				-- end
				-- framesUsed = framesUsed..frame
			-- end
		-- end
		-- if not(vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["rw"]["spellsToCheck"]["useSpellProfile"]) then
			-- if framesUsed ~= "" then
				-- framesUsed = framesUsed..", "
			-- end
			-- framesUsed = framesUsed.."RW"
		-- end
		-- if framesUsed == "" then
			-- returnvalue[""] = "|CFF00ced1Preset|r"
		-- else
			-- returnvalue[""]="|CFF00ced1Preset|r ("..framesUsed..")"
		-- end
	-- elseif timer == 0 then
		-- returnvalue[""] = "No saved profile found"
	-- end
	
	return returnvalue
end

function vexalarm.options.spells.profiles.create()
	local spellprofile = vexalarm.options.spells.profiles.name
	
	if vexalarm.options.general.checkName(spellprofile) then
		vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][spellprofile] = vexalarm.lib.copyTable(vexalarm.defaults.spells)
		
		vexalarm.options.spells.profiles.feedback("save", "Spell-profile '"..vexalarm.options.spells.profiles.name.."' created successfully", false)
		
		vexalarm.options.spells.profiles.name = ""
	end
end

function vexalarm.options.spells.profiles.save()
	local spellprofile = vexalarm.options.spells.profiles.name
	
	if vexalarm.options.general.checkName(spellprofile) then
		if vexalarm.options.spells.profiles.current=="" then
			vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][spellprofile] = vexalarm.lib.copyTable(vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spells"])
		else
			vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][spellprofile] = vexalarm.lib.copyTable(vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.profiles.current])
		end
		
		vexalarm.options.spells.profiles.feedback("save", "Spell-profile '"..vexalarm.options.spells.profiles.name.."' saved successfully", false)
		
		vexalarm.options.spells.profiles.name = ""
	end
end

function vexalarm.options.spells.profiles.rename()
	local key = vexalarm.options.spells.profiles.current
	local name = vexalarm.options.spells.profiles.newName
	
	if vexalarm.options.general.checkName(name) and vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][key]~=nil then
		if name ~= key then
			vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][name] = vexalarm.lib.copyTable(vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][key])
			vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][key] = nil
			vexalarm.options.spells.profiles.newName = name
			vexalarm.options.spells.profiles.current = name
			for frame in pairs(vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"]) do
				if vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["spellsToCheck"]["spellProfile"] == key then
					vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["frames"][frame]["spellsToCheck"]["spellProfile"] = name
				end
			end
			vexalarm.options.spells.profiles.feedback("rename", "Spell-profile renamed successfully", false)
		else
			vexalarm.options.spells.profiles.feedback("rename", "Couldn't rename profile. Reason: The new name and the old name are the same.", true)
		end
	end
end

function vexalarm.options.spells.profiles.delete()
	local key = vexalarm.options.spells.profiles.current
	
	if vexalarm.options.general.checkName(key) then
		vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][key] = nil
		vexalarm.options.spells.profiles.current = ""
		vexalarm.options.spells.profiles.newName = ""
			
		vexalarm.options.spells.profiles.feedback("load", "Spell-profile deleted successfully", false)
	end
end

function vexalarm.options.spells.profiles.load(key, slashcmd)
	if key == nil then
		key = vexalarm.options.spells.profiles.current
	end
	if vexalarm.options.general.checkName(key) then
		if vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][key] == nil then
			if slashcmd then
				print("|CFFFF7D0AVex Alarm|r - ERROR - Couldn't load spell-profile. Reason: Spell-profile '"..key.."' doesn't exist.")
			else
			vexalarm.options.spells.profiles.feedback("load", "Couldn't load spell-profile. Reason: Spell-profile '"..key.."' doesn't exist.", true)
			end
		else
			vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spells"] = vexalarm.lib.copyTable(vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][key])
			vexalarm.initialize.loadSV(false)
			if slashcmd then
				print("|CFFFF7D0AVex Alarm|r - Spell-profile '"..key.."' has been loaded succesfully")
			else
				vexalarm.options.spells.profiles.feedback("load", "Spell-profile '"..key.."' has been loaded succesfully", false)
			end
		end
	end
end

function vexalarm.options.spells.profiles.incSP.getList()
	local returnvalue = {}
	local empty = true
	for key,val in pairs(vexalarm.incomeSpellProfiles) do
		returnvalue[key] = val["timestamp"].." "..val["name"]
		empty = false
	end
	if empty then
		returnvalue[""] = "No received profile found"
	end
	return returnvalue
end

function vexalarm.options.spells.profiles.incSP.save()
	local key = vexalarm.options.spells.profiles.incSP.name
	local name = vexalarm.options.spells.profiles.incSP.newName
	if vexalarm.options.general.checkName(name) then
		vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][name] = vexalarm.lib.copyTable(vexalarm.incomeSpellProfiles[key]["data"])
		vexalarm.incomeSpellProfiles[key] = nil
		vexalarm.options.spells.profiles.incSP.name = ""
		vexalarm.options.spells.profiles.incSP.newName = ""
		
		vexalarm.options.spells.profiles.feedback("saveRe", "Received spell-profile saved successfully", false)
	end
end


function string:VEXALARM_SPlitter(splitter)
	local returnvalue = {}
	for part in string.gmatch(self, ".-"..splitter) do
		part = string.gsub(part, splitter, "")
		returnvalue[#returnvalue+1] = part
	end
	return returnvalue
end

function vexalarm.options.spells.profiles.incSP.re(msg, sender)
	if vexalarm.sentMsgs[msg] == sender then
		vexalarm.sentMsgs[msg] = nil
		vexalarm.SendSuccess = true
		
		print("|CFFFF7D0AVex Alarm|r - |CFF00FF00Spellprofile has been successfully sent|r")
	end
end


function vexalarm.options.spells.profiles.incSP.successTimer()
	vexalarm.testmode.handler(false)
	local test_aniGRP = vexalarm_event_frame:CreateAnimationGroup("vexalarm.options.spells.profiles.incSP.successTimer")
	test_aniGRP:SetLooping("NONE")
	local test_ani = test_aniGRP:CreateAnimation("Scale")
	test_ani:SetOrder(1)
	test_ani:SetDuration(0)
	test_ani:SetScale(1,1)
	test_ani:SetEndDelay(5)
	test_aniGRP:SetScript("OnFinished",
		function ()
			if not(vexalarm.SendSuccess) then
				print("|CFFFF7D0AVex Alarm|r - |CFFC41F3BSpellprofile couldn't be delivered|r")
			end
		end)
	test_aniGRP:Play()
end


function vexalarm.options.spells.profiles.incSP.record(msg, sender)
	local content = msg:VEXALARM_SPlitter(";")	
			
	local timestamp = content[1]
	local name = content[2]
	local part = tonumber(content[3])
	local quantity = tonumber(content[4])
	local package = content[5]
	
	if vexalarm.incomeMsgs[timestamp] == nil then
		vexalarm.incomeMsgs[timestamp] = {}
	end
	
	if vexalarm.incomeMsgs[timestamp]["parts"] == nil then
		vexalarm.incomeMsgs[timestamp]["parts"] = {}
	end
	
	if vexalarm.incomeMsgs[timestamp]["received"] == nil then
		vexalarm.incomeMsgs[timestamp]["received"] = {}
		for i=1, quantity do
			vexalarm.incomeMsgs[timestamp]["received"][i] = false
		end
	end
	
	vexalarm.incomeMsgs[timestamp]["received"][part] = true
	vexalarm.incomeMsgs[timestamp]["quantity"] = quantity
	vexalarm.incomeMsgs[timestamp]["parts"][part] = package
	
	
	local complete = true
	for i,v in ipairs(vexalarm.incomeMsgs[timestamp]["received"]) do
		if not(v) then
			complete = false
		end
	end
	
	if complete then
		vexalarm.incomeSpellProfiles[timestamp] = {}
		
		local text = ""
		for i,v in ipairs(vexalarm.incomeMsgs[timestamp]["parts"]) do
			text = text..v
		end
	
		local data = {}
		local spells = text:VEXALARM_SPlitter(",")
		local timer = 0
		for i, v in ipairs(spells) do
			local spelldata = v:VEXALARM_SPlitter("=")
			
			data[spelldata[1]] = {}
			
			for j=1,4 do
				data[spelldata[1]][j] = string.sub(spelldata[2], j, j) == "1"
			end
		end
				
		vexalarm.incomeSpellProfiles[timestamp]["data"] = data
						
		vexalarm.incomeSpellProfiles[timestamp]["timestamp"] = date("%d/%m/%y %H:%M")
		vexalarm.incomeSpellProfiles[timestamp]["name"] = name	
		vexalarm.initialize.core(true)
		print("|CFFFF7D0AVex Alarm|r - Spellprofile '"..name.."' from '"..sender.."' has been received")
		SendAddonMessage("VEXALARM_SP_RE", timestamp , "whisper" , sender)	
	end
end

function vexalarm.options.spells.profiles.incSP.send()
	local user = vexalarm.options.spells.profiles.target
	local packages = {}
	local timer = 0
	local currentpackage = 1
	
	vexalarm.SendSuccess = false
	
	local spellprofile = {}
	if vexalarm.options.spells.profiles.current == "" then
		spellprofile = vexalarm.lib.copyTable(vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spells"])
	else
		if vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.profiles.current]~=nil then
			spellprofile = vexalarm.lib.copyTable(vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.profiles.current])
		else 
			spellprofile = nil
		end
	end
	
	if spellprofile~= nil and user ~= "" then
		for key in pairs(vexalarm.defaults.spells) do
			if timer>=15 then
				currentpackage = currentpackage + 1
				timer = 0
			end
			timer = timer + 1
			
			if packages[currentpackage] == nil then
				packages[currentpackage] = ""
			end
			
			local text = key.."="
			for i=1,4 do
				local boolean = 0
				if spellprofile[key] ~= nil then
					if spellprofile[key][i] ~= nil then
						if spellprofile[key][i] then
							boolean = 1
						end
					end
				end
				text = text..boolean
			end
			text = text.."="
			
			packages[currentpackage] = packages[currentpackage]..text..","
		end
	end
	local msgcount = #packages
	if msgcount > 0 then
		local timestamp = GetTime()
		for i=1,msgcount do
			local text = timestamp..";"..vexalarm.options.spells.profiles.current..";"..i..";"..msgcount..";"..packages[i]..";"
			SendAddonMessage("VEXALARM_SP", text , "whisper" , user)
		end
		vexalarm.sentMsgs[tostring(timestamp)] = user
		vexalarm.options.spells.profiles.incSP.successTimer()
		print("|CFFFF7D0AVex Alarm|r - |CFF00FF00Spellprofile '"..vexalarm.options.spells.profiles.current.."' is on its way to '"..user.."'|r")
	end
end