vexalarm.options.spells.settings.class = 12

vexalarm.options.spells.settings.SP = ""
vexalarm.options.spells.settings.name = ""
vexalarm.options.spells.settings.dataToAdjust = "roles"


function vexalarm.options.spells.settings.getListSorted(class)
	local returnvalue = {}
	-- get all spells of the category
	local place = 1
	for key, val in pairs(vexalarm.defaults.spells) do	
		if val[5] == class then
			if select(1, GetSpellInfo(tonumber(key)))~=nil then
				local spellname = string.lower(select(1, GetSpellInfo(tonumber(key))))
				if vexalarm.options.spells.settings.name == "" or string.find(spellname,string.lower(vexalarm.options.spells.settings.name))~= nil then
					if select(1, GetSpellInfo(tonumber(key))) ~= nil then
						returnvalue[place] = {select(1, GetSpellInfo(tonumber(key))), key}
						place = place + 1
					else
						vexalarm.wrongspells[key] = key
					end
				end
			end
		end
	end
	table.sort(returnvalue, function(a,b) return a[1]<b[1] end)
	return returnvalue
end

function vexalarm.options.spells.settings.getClassFilter()
	if vexalarm.options.spells.settings.class == 12 then
		return 1
	elseif vexalarm.options.spells.settings.class ~= 0 then
		return vexalarm.options.spells.settings.class +1
	else
		return vexalarm.options.spells.settings.class
	end
end

function vexalarm.options.spells.settings.setClassFilter(val)
	if val == 1 then
		val = 12
	elseif val~= 0 then
		val = val-1
	end
	vexalarm.options.spells.settings.class = val
end

function vexalarm.options.spells.settings.createButton(rolestring, enable, role, rank)
	local image = "Interface/LFGFRAME/UI-LFG-ICON-ROLES"
	local size = 25
	local returnvalue = {
		name = enable[1].." "..rolestring,
		func = function(info,val) vexalarm.options.spells.settings.toggleSpell(enable[3], role) end,
		order=rank,
		type = "execute",
		width="half"}
	-- if role~=4 then returnvalue.width="half" end
	if role == 1 then
		returnvalue.image=image		returnvalue.imageWidth=size		returnvalue.imageHeight=size
		returnvalue.imageCoords={0.02,	0.25,	0.25,	0.5}
	elseif role == 2 then
		returnvalue.image=image		returnvalue.imageWidth=size		returnvalue.imageHeight=size
		returnvalue.imageCoords={0.262,	0.523,	0,		0.262}
	elseif role == 3 then
		returnvalue.image=image		returnvalue.imageWidth=size		returnvalue.imageHeight=size
		returnvalue.imageCoords={0.262,	0.523,	0.25,	0.5}
	elseif role == 4 then
		returnvalue.image=image		returnvalue.imageWidth=size		returnvalue.imageHeight=size
		returnvalue.imageCoords={0.262,	0.523,	0.52,	0.77}
	else
		returnvalue.image=image		returnvalue.imageWidth=size		returnvalue.imageHeight=size
		returnvalue.imageCoords={0.02,	0.25,	0,	0.262}
		returnvalue.width="normal"
	end
	return returnvalue
end

function vexalarm.options.spells.settings.createToolTipButton(spellid, rank, class, classstring)
	local returnvalue = {
		name = "show tooltip",
		func = function(info,val) vexalarm.options.spellwindow.toggle(false, tonumber(spellid), class, classstring) end,
		order=rank, type = "execute",
		width="normal"}
	return returnvalue
end

function vexalarm.options.spells.settings.createSpellButton(key, rank, class, classstring)
	local returnvalue = {
		func = function(info,val) vexalarm.options.spellwindow.toggle(false, tonumber(key), class, classstring) end,
		order=rank, type = "execute",
		width="normal",
		image =select(3, GetSpellInfo(tonumber(key)))}
	
	local spellname = vexalarm.colorize.class(select(1, GetSpellInfo(tonumber(key))), key, "spell")		--.." (ID:"..key..")"
	local advanced_tooltip = {
		["77764"] = " (cat form)",		--Stampeding Roar
		["77761"] = " (bear form)",		--Stampeding Roar
		["106898"] = " (no form)",		--Stampeding Roar
		["117679"] = vexalarm.colorize.class(": Tree of Life", "117679", "spell"),
		["49376"] = " (cat form)",		--Wild Charge
		["16979"] = " (bear form)",		--Wild Charge
		["102383"] = " (moonkin form)",	--Wild Charge
		["102401"] = " (no form)",		--Wild Charge
		["102417"] = " (travel form)",	--Wild Charge
		["102416"] = " (swim form)",	--Wild Charge
		}
	if advanced_tooltip[key] ~= nil then
		returnvalue.name = spellname..advanced_tooltip[key]
	else
		returnvalue.name = spellname
	end
	
	return returnvalue
end

function vexalarm.options.spells.settings.createDesc(key, rank)
	local returnvalue = {fontSize="large", image = select(3, GetSpellInfo(tonumber(key))), type="description", order=rank, width="double"}
	local spellname = vexalarm.colorize.class(select(1, GetSpellInfo(tonumber(key))), key, "spell")		--.." (ID:"..key..")"
	local advanced_tooltip = {
		["77764"] = " (cat form)",		--Stampeding Roar
		["77761"] = " (bear form)",		--Stampeding Roar
		["106898"] = " (no form)",		--Stampeding Roar
		["117679"] = vexalarm.colorize.class(": Tree of Life", "117679", "spell"),
		["49376"] = " (cat form)",		--Wild Charge
		["16979"] = " (bear form)",		--Wild Charge
		["102383"] = " (moonkin form)",	--Wild Charge
		["102401"] = " (no form)",		--Wild Charge
		["102417"] = " (travel form)",	--Wild Charge
		["102416"] = " (swim form)",	--Wild Charge
		}
	if advanced_tooltip[key] ~= nil then
		returnvalue.name = spellname..advanced_tooltip[key]
	else
		returnvalue.name = spellname
	end
	
	return returnvalue
end

function vexalarm.options.spells.settings.createToggleTarget(spellid, rank)	
	local returnvalue = {
		name = "Target",
		order=rank, type = "toggle", width="half", disabled=not(vexalarm.options.spells.settings.getTargetDisabled(spellid)),
		desc = "Show the target of the spell in the output-message",
		set = function(info,val) vexalarm.options.spells.settings.setTarget(spellid, val) end,
		get = function() return vexalarm.options.spells.settings.getTarget(spellid) end
		}
	return returnvalue
end

function vexalarm.options.spells.settings.createToggleTrackBuff(spellid, rank)	
	local returnvalue = {
		name = "Buff",
		order=rank, type = "toggle", width="half", disabled=not(vexalarm.options.spells.settings.getTrackBuffDisabled(spellid)),
		desc = "When a buff is tracked the addon will post a message when the buff is applied and when it is removed. Deactivating this will only post a message when the buff is applied and not when the buff fades.",
		set = function(info,val) vexalarm.options.spells.settings.setTrackBuff(spellid, val) end,
		get = function() return vexalarm.options.spells.settings.getTrackBuff(spellid) end
		}
	return returnvalue
end

function vexalarm.options.spells.settings.createToggleSelfcastOnly(spellid, rank)	
	local returnvalue = {
		name = "Selfcast only",
		order=rank, type = "toggle", width="normal",
		desc = "This spell will only be tracked if you casted it yourself.",
		set = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP][spellid][9]=val end,
		get = function() return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP][spellid][9] end
		}
	return returnvalue
end

function vexalarm.options.spells.settings.createToggle(rolestring, key, role, rank)	
	local returnvalue = {
		name = rolestring,
		-- name = " ",
		order=rank, type = "toggle", width="half",
		desc = "Output when the caster's role is '"..rolestring.."'",
		set = function(info,val) vexalarm.options.spells.settings.setSpell(key, role, val) end,
		get = function() return vexalarm.options.spells.settings.getSpell(key, role) end
		}
		
	local image = "Interface/LFGFRAME/UI-LFG-ICON-ROLES"
	local size = 25
	if role == 1 then
		returnvalue.image=image		--returnvalue.imageWidth=size		returnvalue.imageHeight=size
		returnvalue.imageCoords={0.02,	0.25,	0.25,	0.5}
	elseif role == 2 then
		returnvalue.image=image		--returnvalue.imageWidth=size		returnvalue.imageHeight=size
		returnvalue.imageCoords={0.262,	0.523,	0,		0.262}
	elseif role == 3 then
		returnvalue.image=image		--returnvalue.imageWidth=size		returnvalue.imageHeight=size
		returnvalue.imageCoords={0.262,	0.523,	0.25,	0.5}
	elseif role == 4 then
		returnvalue.image=image		--returnvalue.imageWidth=size		returnvalue.imageHeight=size
		returnvalue.imageCoords={0.262,	0.523,	0.52,	0.77}
	else
		returnvalue.name = enable[1].." "..rolestring
	end
	return returnvalue
end

function vexalarm.options.spells.settings.getTarget(spellid)
	local spelltype = ""
	if vexalarm.options.spells.settings.SP == "" then
		spelltype = vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spells"][spellid][6]
	elseif vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP] ~= nil then
		spelltype = vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP][spellid][6]
	end
	
	local returnvalue = true
	if spelltype == "buffWOtarget" or spelltype=="castWOtarget" then
		returnvalue = false
	end
	return returnvalue
end

function vexalarm.options.spells.settings.getTrackBuff(spellid)
	local returnvalue = true
	local spelltype = ""
	
	if vexalarm.options.spells.settings.SP == "" then
		spelltype = vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spells"][spellid][6]
	elseif vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP] ~= nil then
		spelltype = vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP][spellid][6]
	end
	if spelltype == "castWOtarget" or spelltype=="castWtarget" then
		returnvalue = false
	end
	
	return returnvalue
end

function vexalarm.options.spells.settings.setTarget(spellid, val)
	if vexalarm.options.spells.settings.SP == "" then
		local spelltype = vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spells"][spellid][6]
		if spelltype=="buffWtarget" or spelltype=="buffWOtarget" then
			if val then
				vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spells"][spellid][6] = "buffWtarget"
			else
				vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spells"][spellid][6] = "buffWOtarget"
			end
		else
			if val then
				vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spells"][spellid][6] = "castWtarget"
			else
				vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spells"][spellid][6] = "castWOtarget"
			end
		end
	elseif vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP] ~= nil then
		if vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP][spellid] ~= nil then
			local spelltype = vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP][spellid][6]
			if spelltype=="buffWtarget" or spelltype=="buffWOtarget" then
				if val then
					vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP][spellid][6] = "buffWtarget"
				else
					vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP][spellid][6] = "buffWOtarget"
				end
			else
				if val then
					vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP][spellid][6] = "castWtarget"
				else
					vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP][spellid][6] = "castWOtarget"
				end
			end
		end
	end
end

function vexalarm.options.spells.settings.setTrackBuff(spellid, val)
	if vexalarm.options.spells.settings.SP == "" then
		local spelltype = vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spells"][spellid][6]
		if spelltype=="buffWtarget" or spelltype=="castWtarget" then
			if val then
				vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spells"][spellid][6] = "buffWtarget"
			else
				vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spells"][spellid][6] = "castWtarget"
			end
		else
			if val then
				vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spells"][spellid][6] = "buffWOtarget"
			else
				vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spells"][spellid][6] = "castWOtarget"
			end
		end
	elseif vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP] ~= nil then
		if vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP][spellid] ~= nil then
			local spelltype = vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP][spellid][6]
			if spelltype=="buffWtarget" or spelltype=="castWtarget" then
				if val then
					vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP][spellid][6] = "buffWtarget"
				else
					vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP][spellid][6] = "castWtarget"
				end
			else
				if val then
					vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP][spellid][6] = "buffWOtarget"
				else
					vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP][spellid][6] = "castWOtarget"
				end
			end
		end
	end
end

function vexalarm.options.spells.settings.getTrackBuffDisabled(spellid)
	local spelltype = vexalarm.defaults.spells[spellid][6]
	local returnvalue = true
	if spelltype == "castWOtarget" or spelltype=="castWtarget" then
		returnvalue = false
	end
	return returnvalue
end

function vexalarm.options.spells.settings.getTargetDisabled(spellid)
	local spelltype = vexalarm.defaults.spells[spellid][6]
	local returnvalue = true
	if spelltype == "castWOtarget" or spelltype=="buffWOtarget" then
		returnvalue = false
	end
	return returnvalue
end

function vexalarm.options.spells.settings.setSpell(spell, role, newval)
	if vexalarm.options.spells.settings.SP == "" then
		if vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spells"][spell] == nil then
			vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spells"][spell]={}
		end
		vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spells"][spell][role]=newval
		
	elseif vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP] ~= nil then
		if vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP][spell] == nil then
			vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP][spell]={}
		end
		vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP][spell][role]=newval
	end
	vexalarm.testmode.delayTimer()
end

function vexalarm.options.spells.settings.getSpell(spell, role)
	if vexalarm.options.spells.settings.SP == "" then
		if vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spells"][spell]==nil then
			return false
		else
			return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spells"][spell][role]
		end
	elseif vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP] ~= nil then
		if vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP][spell] == nil then
			return false
		else
			return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP][spell][role]
		end
	else
		return false
	end
end

function vexalarm.options.spells.settings.toggleSpell(newval, role)
	local spelltypes = {"buffWtarget", "buffWOtarget", "grpbuff", "castWtarget", "castWOtarget"}
	local classnames = {"DEATHKNIGHT", "DRUID", "HUNTER", "MAGE", "MONK", "PALADIN", "PRIEST", "ROGUE", "SHAMAN", "WARLOCK", "WARRIOR", ""}
	local class = classnames[vexalarm.options.spells.settings.class]
	local name = vexalarm.options.spells.settings.name	
	for key,val in pairs(vexalarm.defaults.spells) do
		if val[5] == class then			
			local spellname = select(1, GetSpellInfo(tonumber(key)))
			if spellname~=nil then
				spellname = string.lower(spellname)
				if name == "" or string.find(spellname,string.lower(name))~= nil then 
					if vexalarm.options.spells.settings.SP == "" then
						if vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spells"][key] == nil then
							vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spells"][key] = vexalarm.lib.copyTable(vexalarm.defaults.spells[key])
						end
						if role == nil then
							for i=1,4 do
								vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spells"][key][i] = newval
							end
						else
							vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spells"][key][role] = newval
						end
					elseif vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP] ~= nil then
						if vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP][key] == nil then
							vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP][key] = vexalarm.lib.copyTable(vexalarm.defaults.spells[key])
						end
						if role == nil then
							for i=1,4 do
								vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP][key][i] = newval
							end
						else
							vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["spellprofiles"][vexalarm.options.spells.settings.SP][key][role] = newval
						end
					end
				end
			end
		end
	end
	vexalarm.testmode.delayTimer()
end