function vexalarm.options.profiles.panel()
	
	if vexalarm.options.profiles.current == "" then
	vexalarm.options.profiles.current = vexalarm_SV_data["profile"]
	end
	
	return {
		type = "group",
		args = {
			grpcreate = {
				name = "Create and edit",
				order=5, type ="group", dialogInline = true,
				args = {
					profile = {
						name = "Existing profiles",
						order=1, type = "select", style = "dropdown", width="double",
						values = vexalarm.options.profiles.getList(true),
						set = function(self,key)
							vexalarm.options.profiles.current = key
							vexalarm.initialize.core(true)
							end,
						get = function() return vexalarm.options.profiles.current end,
						},
					newname = {
						name = "New name",
						order=2, type = "input", width="normal",
						disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.profiles.getList(), vexalarm.options.profiles.current),
						set = function(info,val) vexalarm.options.profiles.name = val vexalarm.initialize.core(true) end,
						get = function() return vexalarm.options.profiles.name end,
						},
					profile_new_add = {
						name = "create new",
						order=10, type = "execute", width="normal",
						disabled = not(vexalarm.options.general.checkName(vexalarm.options.profiles.name)),
						func = function(info,val) vexalarm.options.profiles.save() vexalarm.initialize.core(true) end,
						confirm = vexalarm_SV_profileData[vexalarm.options.profiles.name]~= nil,
						confirmText = "A profile with that name allready exists. Do you want to overwrite it ?",
						},
					profile_clone = {
						name = "create clone",
						order=11, type = "execute", width="normal",
						disabled = not(vexalarm.options.general.checkName(vexalarm.options.profiles.name)),
						func = function(info,val) vexalarm.options.profiles.clone() vexalarm.initialize.core(true) end,
						confirm = vexalarm_SV_profileData[vexalarm.options.profiles.name]~= nil,
						confirmText = "A profile with that name allready exists. Do you want to overwrite it ?",
						},
					space2 = {name = " ", type = "description", order=12, width="half"},
					-- changename = {
						-- name = "rename",
						-- order=12, type = "execute",
						-- disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.profiles.getList(), vexalarm.options.profiles.current) or vexalarm.options.profiles.name=="" or vexalarm.options.profiles.current == "Default",
						-- func = function(info,val) vexalarm.options.profiles.rename() vexalarm.initialize.core(true) end,
						-- confirm = vexalarm_SV_profileData[vexalarm.options.profiles.name]~= nil,
						-- confirmText = "A profile with the new name allready exists. Do you want to overwrite it ?",
						-- },
					load_exe_all = {
						name = "load all",
						order=20, type = "execute", desc="load frames, raid-warnings and 'current-spell'settings as well as spellprofiles",
						disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.profiles.getList(), vexalarm.options.profiles.current),
						func = function(info,val) vexalarm.options.profiles.load("all") vexalarm.initialize.core(true) end,
						},
					delete_exe = {
						name = "delete",
						order=21, type = "execute",
						disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.profiles.getList(), vexalarm.options.profiles.current) or vexalarm.options.profiles.current == vexalarm_SV_data["profile"],
						func = function(info,val) vexalarm.options.profiles.delete() vexalarm.initialize.core(true) end,
						confirm = true,
						confirmText = "Do you really want to delete this profile?"
						},
					space = {name = " ", type = "description", order=22, width="half"},
						
					load_exe_frames = {
						name = "load frames",
						order=30, type = "execute",
						disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.profiles.getList(), vexalarm.options.profiles.current),
						func = function(info,val) vexalarm.options.profiles.load("frames") vexalarm.initialize.core(true) end,
						},
					load_exe_settings = {
						name = "load raid-warnings",
						order=31, type = "execute",
						disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.profiles.getList(), vexalarm.options.profiles.current),
						func = function(info,val) vexalarm.options.profiles.load("rw") vexalarm.initialize.core(true) end,
						},
					load_exe_spells = {
						name = "load spell-profiles",
						order=32, type = "execute",
						disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.profiles.getList(), vexalarm.options.profiles.current),
						func = function(info,val) vexalarm.options.profiles.load("spelldata")  vexalarm.initialize.core(true) end,
						},
					status = {name = vexalarm.options.profiles.statusMsg["rename"]..""..vexalarm.options.profiles.statusMsg["load"]..""..vexalarm.options.profiles.statusMsg["delete"], type = "description", order=50},
					},
				},
			}
		}
end








